#include <stddef.h>
#include <tos.h>
#include <mt_aes.h>
#include <vdi.h>
#include <string.h>
#include <ext.h>
#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>

#define TRUE 	1
#define FALSE 0

#include "..\include\dracdlg.h"
#include "..\include\slbload.h"

#include "..\socket\stsocket.h"
#include "mail.h"
#include "struct.h"
#include "prototyp.h"
#include "marathon.h"

#define SVERSION_ID17 0x0107
#define SVERSION_ID20 0x0200
#define SVERSION_ID SVERSION_ID20

#define VERSION_ID17 0x00010007L
#define VERSION_ID20 0x00020000L
#define VERSION_ID201	0x00020001L
#define VERSION_ID VERSION_ID201

#define CFG_ID 'dCfg'
#define MagX_COOKIE 'MagX'
#define MiNT_COOKIE 'MiNT'

extern unsigned char from_ansi[], to_ansi[];

extern int 								vdi_handle;								/* VDI-Handle				*/
extern int 								work_in[11];							/* Workstationinfo	*/
extern int 								work_out[57];							/*          "				*/

extern int aes_version, gl_apid, gdos, naes;

extern GRECT empty;
extern int which, msg[8];
extern EVNTDATA evnt;
extern int k_return, clicks;

extern int box_wind, box_top;
extern char browserpath[80], mailpath[256], helpfile[256];
extern OBJECT *menu_adr, *limits;
extern int icon_height, box_wd[4], iheight, isize;
extern int exit_flg;

/* Pop window */
extern int pop_wind;
extern int pop_sort, pop_cols[10];								/* Boxcols mit Reserve */	/* 0-4 belegt */
extern int pop_wd[4];															/* 5 = New 2.0 -> Identity */

/* Tree window */
extern int tree_wind, tree_top, tree_selection;
extern int tree_wd[4];

/* Buttons */
extern int tool_button_no, box_icons_no;
extern char iconbfile[9];
extern PALETTE_FILE tool_palheader, icon_palheader;

extern PROVIDER *providers;
extern int prov_cnt;
extern CFG_OPT cfg_options;
extern MAIL_OPT mail_options;

extern int mail_wind, edit_mode, forward_mode, full_header;
extern char mail_title[256], edit_file[13], edit_box[13];
extern int epart_count;
extern PART_INFO *edit_parts;
extern int tx_width, tx_height, default_fsize;
extern int num_fonts;

/* Mail flags/buffer */
extern int no_refresh;
extern MAIL_MEM new_buffer;
extern int word_wrap;

extern int box_open, box_count, box_background;
extern BOX_INFO  	*boxes;
extern BOX_MANAGER *box_manager;

extern char pbox_text[20];

extern char hexchar[];

/* Pop window */
extern char pop_password[43];
extern char pop_username[43];

extern char *m_desc[12];
extern int mime_flg;
extern char b64alpha[];

extern char *enc_tab[];
extern long encoding_offset, encoded_content;

/* Poll window */
extern int poll_wind;

/* Address book */
extern int abookset_wind;
extern OBJECT *abook_tree;

/* Forward dialog */
extern OBJECT *fwd_tree;

/* Read confirmation */
extern int   confirm_read;
extern char  confirm_addr[512];

/* Images */
extern int colours, dither_index, dither_colours, planes, truecolor_type, smallfont;
extern char *boxicons, *mw_toolbar, *symbols;

extern char tr_cols[256], tr_base[256];
extern int pixel_type;

/* RSC - Strings */
extern char *inval_box, *reply_text, *fwd_text, *auth_text, *sockfail_msg;
extern char *connect_msg, *disconnect_msg, *smtp_unk_msg, *bigatt_msg;
extern char *invalid_conf, *nodriver_msg, *offline_msg;
extern char *connfail_msg, *tomanywin_msg, *pservice_msg, *boxexists_msg;
extern char *nonews_msg, *nobinatt_msg, *smtpprob_msg, *scanerr_msg;
extern char *boxfail_msg, *rnomark_msg, *rdnomark_msg, *dnomark_msg;
extern char *send_text, *popconn_text, *rcv_text, *rcvdel_text, *del_text;
extern char *mailchk_text, *viewmail_text, *saveatt_text, *processing_text;
extern char *analysing, *sending_text, *encrypt_text, *unsecure_text; 
extern char *getminf_text, *disconn_text, *attachm_text, *follows_text;
extern char *attachinf_text, *forwardmsg_text, *noaddress_text, *nosubject_text;
extern char *s_msgs, *s_msg, *s_mrkd, *s_scanhd, *s_retr, *s_retr2, *s_dele;
extern char *s_edit, *s_fwdm, *s_fwd, *filec_error, *scrap_error;
extern char *send_perc, *delfoldq, *s_messgs, *s_messg, *s_nomssg, *s_marked;
extern char *s_page, *deletemsg, *printmsg, *fileoerr, *notpalet, *waserror;
extern char *changed, *deletethis, *deletenode, *fav_title, *unknownserver;
extern char *h_from, *h_cc, *h_bcc, *h_replyto, *h_subject, *h_to;
extern char *h_identity, *h_signature, *all_string, *none_string, *defid_string;
extern char *languagecode, *idfolder_label, *idfolder_entry;

extern OBJECT *find_tree, *editorselect, *repl_tree;
extern OBJECT *header_tree, *option_tree, *iconified_tree;
extern int opt_pages[4];

#define FNC_GETOPTIONS 45L

#if defined(TRAPIT) && !defined(SMALLTRAP)
#		define	DEBUG()		logfunc(__FILE__,__LINE__) 
#else
#ifdef DEBUG_LOG
#		define 	DEBUG() printf("%s:%d: %s\n", __FILE__,__LINE__,__FUNCTION__);
#else
#		define 	DEBUG()
#endif
#endif

#ifdef DBGMEM
#		define	malloc(a)		dbg_malloc(__FILE__,__LINE__,a)
#		define  free(a)			dbg_free(__FILE__,__LINE__,a)
#		define	realloc(a,b)	dbg_realloc(__FILE__,__LINE__,a,b)
#endif

#ifdef WITH_XFILE
#include "XFILE.H"
#endif