#include "ansi_map.h"

int 								vdi_handle;								/* VDI-Handle				*/
int 								work_in[11];							/* Workstationinfo	*/
int 								work_out[57];							/*          "				*/

int aes_version, gdos, naes;
#ifndef __AHCC__
int gl_apid;
#else
extern int gl_aid;
#endif

GRECT empty = {0,0,0,0};
EVNTDATA evnt;
int k_return, clicks;
int which, msg[8];

int box_wind = -1, box_top = 0;
char browserpath[80], mailpath[256], helpfile[256];

OBJECT *menu_adr, *limits;
int icon_height, box_wd[4], iheight, isize;
int exit_flg = 0;

/* Pop window */
int pop_wind = -1;
int pop_sort, pop_cols[10];											/* Boxcols mit Reserve */	/* 0-4 belegt */
int pop_wd[4];																	/* 5 = New 2.0 -> Identity */

/* Tree window */
int tree_wind = -1, tree_top = 0, tree_selection = -1;
int tree_wd[4];

/* Buttons */
int tool_button_no = -1, box_icons_no = -1;
char iconbfile[9];
PALETTE_FILE tool_palheader, icon_palheader;

PROVIDER *providers = NULL;
int prov_cnt = 0;
CFG_OPT cfg_options;
MAIL_OPT mail_options = {"\0:\\", 				/* maildir 				*/
												 "EMAIL.BOX", 		/* mailfile 			*/
												 0, 							/* pass_coded 		*/
												 1, 							/* save_opt   		*/
												 "\0", 						/* username				*/
												 "\0", 						/* organization 	*/
												 1,								/* eight_allowed 	*/
												 1, 							/* mime_allowed 	*/
												 1, 							/* confirm_read 	*/
												 1, 							/* confirm_rcpt		*/
												 0, 							/* priority				*/
												 0,								/* word_wrap			*/
												 0,								/* send_immediately			*/
												 1,								/* popauth_required			*/
												 0,								/* download_immediately	*/
												 0,								/* delete_rcvd		*/
												 0,								/* startup_check	*/
												 1,								/* allow_readconfirm */
												 0L,							/* maxsize 				*/
												 FALSE,						/* Bubble GEM			*/
												 FALSE,						/* All headlines	*/
												 0,								/* Print mode = direct */
												 1,	1,						/* Print FF/Wrap	*/
												 "\0",						/* Init           */
												 "\0",						/* Exit						*/
												 "{ESC}E",				/* Bold on				*/
												 "{ESC}F",				/* Bold off				*/
												 78, 70,				  /* Page width/height */
												 76,							/* Edit width     */

												 FALSE,						/* From flag			*/
												 TRUE,						/* Subject flag	  */
												 FALSE,						/* BCC flag				*/
												 TRUE,						/* CC flag				*/
												 "Mail server",		/* POP description */
												 TRUE,						/* ANSI Flag			*/
												 "\0",						/* Signature			*/
												 FALSE,						/* Reply to flag	*/
												 "\0",						/* Toolbox file		*/
												 "\0",						/* Printer settings */
													0,							/* Pad */
													
												 76,							/* Viewer length  */
												 8,							  /* Viewer tabs		*/
												 TRUE,						/* Wrap view			*/
												 TRUE,						/* Save view			*/
												 1, 1, 1,					/* Text/Quoted/Link color */
												 1, 13,						/* Font/Size 			*/
												 FALSE, 					/* Reply prompt		*/
												 FALSE,						/* Remove att.		*/
												 TRUE,						/* Open notify		*/
												 FALSE,						/* Play sound			*/
												 "\0",						/* Sound file			*/
												 TRUE,						/* Confirm delete */
												 TRUE,						/* ID Line				*/
#ifdef __AHCC__
												FALSE,						/* Icon cache suspected to be buggy */
#else
												 TRUE,						/* Icon cache			*/
#endif
												 1,								/* Printer font		*/
												 13,							/* Printer fontsize */
												 0, 0,						/* Left/Right			*/
												 1, 2,						/* Top/Bottom			*/
												 0,								/* Line spacing		*/
												 FALSE,						/* Use colours		*/
												 TRUE,						/* Reformat				*/
												 TRUE,						/* print header		*/
												 TRUE,						/* print footer		*/
												 TRUE,						/* print attaches	*/
												 };

int mail_wind = -1, edit_mode, forward_mode, full_header = FALSE;
char mail_title[256], edit_file[13], edit_box[13];
int epart_count = 0;
PART_INFO *edit_parts = NULL;
int tx_width, tx_height, default_fsize;
int num_fonts;

/* Mail flags/buffer */
int no_refresh = FALSE;
MAIL_MEM new_buffer;
int word_wrap = TRUE;

int box_open = 0, box_count = 0, box_background = 0;
BOX_INFO	*boxes;
BOX_MANAGER *box_manager;

char pbox_text[20];

char hexchar[] = "0123456789ABCDEF";

/* Pop window */
char pop_password[43] = "\0";
char pop_username[43] = "\0";

char *m_desc[12] = {"Jan", "Feb", "Mar", "Apr", "May", "Jun",
										"Jul", "Aug", "Sep", "Oct", "Nov", "Dec"};
int mime_flg;
char b64alpha[] = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";

char *enc_tab[] = {"7bit", "quoted-printable", "base64",
									 "8bit", "binary", "uuencoded"};
long encoding_offset, encoded_content;

/* Poll window */
int poll_wind = -1;

/* Address book */
int abookset_wind = -1;
OBJECT *abook_tree;

/* Forward dialog */
OBJECT *fwd_tree;

/* Read confirmation */
int   confirm_read;
char  confirm_addr[512];

/* Images */
int colours, dither_index, dither_colours, planes, truecolor_type = 1, smallfont;
char *boxicons, *mw_toolbar, *symbols;

char tr_cols[256], tr_base[256];
int  pixel_type;

/* RSC - Strings */
char *inval_box, *reply_text, *fwd_text, *auth_text, *sockfail_msg;
char *connect_msg, *disconnect_msg, *smtp_unk_msg, *bigatt_msg;
char *invalid_conf, *nodriver_msg, *offline_msg;
char *connfail_msg, *tomanywin_msg, *pservice_msg, *boxexists_msg;
char *nonews_msg, *nobinatt_msg, *smtpprob_msg, *scanerr_msg;
char *boxfail_msg, *rnomark_msg, *rdnomark_msg, *dnomark_msg;
char *send_text, *popconn_text, *rcv_text, *rcvdel_text, *del_text;
char *mailchk_text, *viewmail_text, *saveatt_text, *processing_text;
char *analysing, *sending_text, *encrypt_text, *unsecure_text;
char *getminf_text, *disconn_text, *attachm_text, *follows_text;
char *attachinf_text, *forwardmsg_text, *noaddress_text, *nosubject_text;
char *s_msgs, *s_msg, *s_mrkd, *s_scanhd, *s_retr, *s_retr2, *s_dele;
char *s_edit, *s_fwdm, *s_fwd, *filec_error, *scrap_error;
char *send_perc, *delfoldq, *s_messgs, *s_messg, *s_nomssg, *s_marked;
char *s_page, *deletemsg, *printmsg, *fileoerr, *notpalet, *waserror;
char *changed, *deletethis, *deletenode, *fav_title, *unknownserver;
char *h_from, *h_cc, *h_bcc, *h_replyto, *h_subject, *h_to;
char *h_identity, *h_signature, *all_string, *none_string, *defid_string;
char *languagecode, *idfolder_label, *idfolder_entry;

OBJECT *find_tree, *editorselect, *repl_tree;
OBJECT *header_tree, *option_tree, *iconified_tree;
int opt_pages[4];

	