typedef struct 
							{
							int	 magic;
							int  version;
							int  confirm_read;
							int  confirm_rcpt;
							char word_wrap, priority;
							
																			/* Header information */
						  long header_inf;
							int  date_len;
							int  from_len;
							int  organization_len;
							
							int  to_len;
							int	 cc_len;
							int  bcc_len;
	
							int  subject_len;

																				/* Mailbody information */
							long body_pos;
							long body_len;
							
							int  main_idx;

																				/* Attachment information */
							int  	part_count;
							long	partinfo_pos;

							int  replyto_len;					/* New 1.7 */
							char identity[21];				/* New 2.0 */
							char signature[21];
							
							}FILE_MAIL_MEM;

typedef struct 
							{
							int  changed;
							int  confirm_read;
							int  confirm_rcpt;
							int  priority;
							
							char *date;
							char *from, *replyto;
							char *organization;
							
							char *to;
							char *cc;
							char *bcc;

							char *subject;							

							int  to_max, cc_max, bcc_max, from_max, subj_max, replyto_max;
							
							int  max_length;
							char *body;
							long body_len;
							int  body_lines;
							
							char **attachments;
							int  attach_count;
							int	 *att_encoding;
							int	 has_attachments;
							
							char identity[21];		/* New 2.0 */
							char signature[21];
							int	 mime_allowed;
							int  word_wrap;
							int  editwidth;
							
							}MAIL_MEM;
	
typedef struct 
							{
							int  sel;
							char file[13];
							char from[61];
							char to[61];
							char subject[61];
							char date[51];
							long body_len;
							char 	identity[21+1];	/* New 2.0 */
							short	color;					/* New 2.0 */
							short	readonly;				/* New 2.0 */
							}MAIL_INFO;

typedef struct pop_info
							{
							int sel;
							int num;
							int new_num;
							long size;
							char from[61];
							char to[61];
							char subject[61];
							char date[51];
							char identity[21];
							}POP_MEM;
							
typedef struct part_info
							{
							long offset, len;
							char name[61];
							char desc[61];
							char type[21];
							}PART_INFO;

typedef struct abook_entry
							{
							char sel, group, open, level;
							char shortname[21];
							char name[46];
							char street[46];
							char city[46];
							char phone[19], fax[19];
							char email1[46], email2[46];
							}ABOOK_ENTRY;							
							