#ifdef WITH_XFILE
#include <tos.h>
#include <stdio.h>

short xcreate( const char * fname, short attr );
short xopen( const char * fname, short mode );
long xwrite( short fd, long cnt, void * buf );
long xread( short fd, long cnt, void * buf );
long xseek( long off, short fd, short mode );
short xclose( short fd );


#define Fopen( path, mode ) xopen( path, mode )
#define Fcreate( path, mode ) xcreate( path, mode )
#define Fread( fd, size, buffer ) xread( fd, size, buffer )
#define Fwrite( fd, size, buffer ) xwrite( fd, size, buffer )
#define Fclose( fd ) xclose( fd )
#define Fseek( offset, handle, mode ) xseek( offset, handle, mode )

#endif